local addonName = ...
local GetContainerNumSlots = C_Container.GetContainerNumSlots
local GetContainerItemCooldown = C_Container.GetContainerItemCooldown
local GetContainerItemLink = C_Container.GetContainerItemLink
local GetContainerItemInfo = C_Container.GetContainerItemInfo
local PickupContainerItem = C_Container.PickupContainerItem
local UseContainerItem = C_Container.UseContainerItem

local f = CreateFrame("Frame")
f:RegisterEvent("ADDON_LOADED")
f:SetScript(
    "OnEvent",
    function(self, event, arg1)
        if (addonName == arg1) then
            local g = CreateFrame("Frame")
            g:RegisterEvent("MERCHANT_SHOW")
            g:RegisterEvent("UI_ERROR_MESSAGE")
            g:RegisterEvent("CINEMATIC_START")
            g:RegisterEvent("TAXIMAP_OPENED")
            g:SetScript(
                "OnEvent",
                function(self, event, arg1, arg2, ...)
                    if event == "CINEMATIC_START" then
                        if not IsControlKeyDown() then
                            CinematicFrame_CancelCinematic()
                        end
                    end
                    if event == "TAXIMAP_OPENED" then
                        Dismount()
                    end
                    if event == "MERCHANT_SHOW" and GoodmanUIDB.AUTOMATION.SELL_JUNK then
                        local bag, slot
                        for bag = 0, 4 do
                            for slot = 0, GetContainerNumSlots(bag) do
                                local link = GetContainerItemLink(bag, slot)
                                if link and (select(3, GetItemInfo(link)) == 0) then
                                    UseContainerItem(bag, slot)
                                end
                            end
                        end
                    end
                end
            )
        end
    end
)
