local UnitAffectingCombat, IsActiveBattlefieldArena = UnitAffectingCombat, IsActiveBattlefieldArena
local UnitIsUnit, UnitExists, UnitClass = UnitIsUnit, UnitExists, UnitClass
local UnitClassification, UnitDetailedThreatSituation = UnitClassification, UnitDetailedThreatSituation
local SecureButton_GetUnit = SecureButton_GetUnit
local Indicator = {}

local function InCombat(unit)
    local _, _, class = UnitClass(unit)

    if UnitAffectingCombat(unit) then
        return true
    else
        if (IsActiveBattlefieldArena() and not (class == 1 or class == 2 or class == 4 or class == 11)) then
            for i = 1, 5, 1 do
                if UnitExists("arenapet" .. i .. "target") or UnitDetailedThreatSituation("player", "arenapet" .. i) or
                        UnitDetailedThreatSituation("party"..i, "arenapet" .. i) then
                    if UnitIsUnit(unit, "arena" .. i) then
                        return true
                    end
                end
            end
        end
    end

    return false
end

local events = {
    ["UNIT_FLAGS"] = true,
    ["PLAYER_TARGET_CHANGED"] = true,
}

local function CreateCombatIndicatorForUnit(frame, isPlayer)
    if not Indicator[frame] then
        local ciFrame = frame:CreateTexture(nil, "BORDER")
        ciFrame:SetPoint("LEFT", frame, "RIGHT", -15, -2)
        ciFrame:SetSize(35, 35)
        ciFrame:SetTexture("Interface\\Icons\\ABILITY_DUALWIELD")
        ciFrame:Hide()
        Indicator[frame] = ciFrame

        frame:RegisterEvent("UNIT_FLAGS")
        frame:HookScript("OnEvent", function(self, event)
            if events[event] and frame:IsShown() then
                local unit = SecureButton_GetUnit(self)
                Indicator[self]:SetShown(InCombat(unit))
                if isPlayer then
                    ciFrame:SetPoint("LEFT", frame, "LEFT", -2, 10)
                elseif UnitClassification(unit) ~= "normal" then
                    ciFrame:SetPoint("LEFT", frame, "RIGHT", -35, 10)
                else
                    ciFrame:SetPoint("LEFT", frame, "RIGHT", -35, 10)
                end
            end
        end)
    end
end

local f = CreateFrame("Frame")
f:RegisterEvent("PLAYER_LOGIN")
f:SetScript("OnEvent", function(self, event)
    if event == "PLAYER_LOGIN" then
        CreateCombatIndicatorForUnit(PlayerFrame, true)
        CreateCombatIndicatorForUnit(TargetFrame)
        self:UnregisterEvent("PLAYER_LOGIN")
        self:SetScript("OnEvent", nil)
    end
end)