-- local addon, ns = ...
-- local cfg = ns.cfg
-- local dragFrameList = {}
-- function rGetPoint(self)
--     if not self then
--         return
--     end
--     local point = {}
--     point.a1, point.af, point.a2, point.x, point.y = self:GetPoint()
--     if point.af and point.af:GetName() then
--         point.af = point.af:GetName()
--     end
--     return point
-- end
-- function rCreateDragFrame(self, dragFrameList, inset, clamp)
--     if not self or not dragFrameList then
--         return
--     end
--     --save the default position for later
--     self.defaultPoint = rGetPoint(self)
--     table.insert(dragFrameList, self) --add frame object to the list
--     --anchor a dragable frame on self
--     local df = CreateFrame("Frame", nil, self)
--     df:SetAllPoints(self)
--     df:SetFrameStrata("HIGH")
--     df:SetHitRectInsets(inset or 0, inset or 0, inset or 0, inset or 0)
--     df:EnableMouse(true)
--     df:RegisterForDrag("LeftButton")
--     df:SetScript(
--         "OnDragStart",
--         function(self)
--             if IsAltKeyDown() and IsShiftKeyDown() then
--                 self:GetParent():StartMoving()
--             end
--         end
--     )
--     df:SetScript(
--         "OnDragStop",
--         function(self)
--             self:GetParent():StopMovingOrSizing()
--         end
--     )
--     df:SetScript(
--         "OnEnter",
--         function(self)
--             GameTooltip:SetOwner(self, "ANCHOR_TOP")
--             GameTooltip:AddLine(self:GetParent():GetName(), 0, 1, 0.5, 1, 1, 1)
--             GameTooltip:AddLine("Hold down ALT+SHIFT to drag!", 1, 1, 1, 1, 1, 1)
--             GameTooltip:Show()
--         end
--     )
--     df:SetScript(
--         "OnLeave",
--         function(s)
--             GameTooltip:Hide()
--         end
--     )
--     df:Hide()
--     --overlay texture
--     local t = df:CreateTexture(nil, "OVERLAY", nil, 6)
--     t:SetAllPoints(df)
--     t:SetTexture(0, 1, 0)
--     t:SetAlpha(0.2)
--     df.texture = t
--     --self stuff
--     self.dragFrame = df
--     self:SetClampedToScreen(clamp or false)
--     self:SetMovable(true)
--     self:SetUserPlaced(true)
-- end
-- --rewrite the oneletter shortcuts
-- -- if cfg.adjustOneletterAbbrev then
-- --   _G.HOUR_ONELETTER_ABBR = "%dh"
-- --   _G.DAY_ONELETTER_ABBR = "%dd"
-- --   _G.MINUTE_ONELETTER_ABBR = "%dm"
-- --   _G.SECOND_ONELETTER_ABBR = "%ds"
-- -- end
-- --backdrop debuff
-- local backdropDebuff = {
--     bgFile = nil,
--     edgeFile = cfg.debuffFrame.background.edgeFile,
--     tile = false,
--     tileSize = 32,
--     edgeSize = cfg.debuffFrame.background.inset,
--     insets = {
--         left = cfg.debuffFrame.background.inset,
--         right = cfg.debuffFrame.background.inset,
--         top = cfg.debuffFrame.background.inset,
--         bottom = cfg.debuffFrame.background.inset
--     }
-- }
-- --backdrop buff
-- local backdropBuff = {
--     bgFile = nil,
--     edgeFile = cfg.buffFrame.background.edgeFile,
--     tile = false,
--     tileSize = 32,
--     edgeSize = cfg.buffFrame.background.inset,
--     insets = {
--         left = cfg.buffFrame.background.inset,
--         right = cfg.buffFrame.background.inset,
--         top = cfg.buffFrame.background.inset,
--         bottom = cfg.buffFrame.background.inset
--     }
-- }
-- local ceil, min, max = ceil, min, max
-- local buffFrameHeight = 0
-- local function applySkin(b)
--     if not b or (b and b.styled) then
--         return
--     end
--     --button name
--     local name = b:GetName()
--     --check the button type
--     local tempenchant, debuff, buff = false, false, false
--     if (name:match("TempEnchant")) then
--         tempenchant = true
--     elseif (name:match("Debuff")) then
--         debuff = true
--     else
--         buff = true
--     end
--     --get cfg and backdrop
--     local cfg, backdrop
--     if debuff then
--         cfg = ns.cfg.debuffFrame
--         backdrop = backdropDebuff
--     else
--         cfg = ns.cfg.buffFrame
--         backdrop = backdropBuff
--     end
--     --button
--     b:SetSize(cfg.button.size, cfg.button.size)
--     --icon
--     local icon = _G[name .. "Icon"]
--     icon:SetTexCoord(0.1, 0.9, 0.1, 0.9)
--     icon:ClearAllPoints()
--     icon:SetPoint("TOPLEFT", b, "TOPLEFT", -cfg.icon.padding, cfg.icon.padding)
--     icon:SetPoint("BOTTOMRIGHT", b, "BOTTOMRIGHT", cfg.icon.padding, -cfg.icon.padding)
--     icon:SetDrawLayer("BACKGROUND", -8)
--     b.icon = icon
--     --border
--     local border = _G[name .. "Border"] or b:CreateTexture(name .. "Border", "BACKGROUND", nil, -7)
--     border:SetTexture(cfg.border.texture)
--     border:SetTexCoord(0, 1, 0, 1)
--     border:SetDrawLayer("BACKGROUND", -7)
--     if tempenchant then
--         border:SetVertexColor(0.7, 0, 1)
--     elseif not debuff then
--         border:SetVertexColor(cfg.border.color.r, cfg.border.color.g, cfg.border.color.b)
--     end
--     border:ClearAllPoints()
--     border:SetAllPoints(b)
--     b.border = border
--     --duration
--     b.duration:SetFont(cfg.duration.font, cfg.duration.size, "THINOUTLINE")
--     b.duration:ClearAllPoints()
--     b.duration:SetPoint(cfg.duration.pos.a1, cfg.duration.pos.x, cfg.duration.pos.y)
--     --count
--     b.count:SetFont(cfg.count.font, cfg.count.size, "THINOUTLINE")
--     b.count:ClearAllPoints()
--     b.count:SetPoint(cfg.count.pos.a1, cfg.count.pos.x, cfg.count.pos.y)
--     --set button styled variable
--     b.styled = true
-- end
-- local function updateDebuffAnchors(buttonName, index)
--     local button = _G[buttonName .. index]
--     if not button then
--         return
--     end
--     --apply skin
--     if not button.styled then
--         applySkin(button)
--     end
--     --position button
--     button:ClearAllPoints()
--     if index == 1 then
--         if cfg.combineBuffsAndDebuffs then
--             button:SetPoint("TOPRIGHT", rBFS_BuffDragFrame, "TOPRIGHT", 0, -buffFrameHeight)
--         else
--             --debuffs and buffs are not combined anchor the debuffs to its own frame
--             button:SetPoint("TOPRIGHT", rBFS_DebuffDragFrame, "TOPRIGHT", 0, 0)
--         end
--     elseif index > 1 and mod(index, cfg.debuffFrame.buttonsPerRow) == 1 then
--         button:SetPoint(
--             "TOPRIGHT",
--             _G[buttonName .. (index - cfg.debuffFrame.buttonsPerRow)],
--             "BOTTOMRIGHT",
--             0,
--             -cfg.debuffFrame.rowSpacing
--         )
--     else
--         button:SetPoint("TOPRIGHT", _G[buttonName .. (index - 1)], "TOPLEFT", -cfg.debuffFrame.colSpacing, 0)
--     end
-- end
-- local function updateAllBuffAnchors()
--     local buttonName = "BuffButton"
--     local numEnchants = BuffFrame.numEnchants
--     local numBuffs = BUFF_ACTUAL_DISPLAY
--     local offset = numEnchants
--     local realIndex, previousButton, aboveButton
--     TempEnchant1:ClearAllPoints()
--     TempEnchant1:SetPoint("TOPRIGHT", rBFS_BuffDragFrame, "TOPRIGHT", 0, 0)
--     --calculate the previous button in case tempenchant or consolidated buff are loaded
--     if BuffFrame.numEnchants > 0 then
--         previousButton = _G["TempEnchant" .. numEnchants]
--     end
--     if numEnchants > 0 then
--         aboveButton = TempEnchant1
--     end
--     --loop on all active buff buttons
--     local buffsCount = 0
--     for index = 1, numBuffs do
--         local button = _G[buttonName .. index]
--         if not button then
--             return
--         end
--         buffsCount = buffsCount + 1
--         if not button.styled then
--             applySkin(button)
--         end
--         --position button
--         button:ClearAllPoints()
--         realIndex = buffsCount + offset
--         if realIndex == 1 then
--             button:SetPoint("TOPRIGHT", rBFS_BuffDragFrame, "TOPRIGHT", 0, 0)
--             aboveButton = button
--         elseif realIndex > 1 and mod(realIndex, cfg.buffFrame.buttonsPerRow) == 1 then
--             button:SetPoint("TOPRIGHT", aboveButton, "BOTTOMRIGHT", 0, -cfg.buffFrame.rowSpacing)
--             aboveButton = button
--         else
--             button:SetPoint("TOPRIGHT", previousButton, "TOPLEFT", -cfg.buffFrame.colSpacing, 0)
--         end
--         previousButton = button
--     end
--     --calculate the height of the buff rows for the debuff frame calculation later
--     local rows = ceil((buffsCount + offset) / cfg.buffFrame.buttonsPerRow)
--     local height = cfg.buffFrame.button.size * rows + cfg.buffFrame.rowSpacing * rows + cfg.buffFrame.gap * min(1, rows)
--     buffFrameHeight = height
--     --make sure the debuff frames update the position asap
--     if DebuffButton1 and cfg.combineBuffsAndDebuffs then
--         updateDebuffAnchors("DebuffButton", 1)
--     end
-- end
-- ---------------------------------------
-- -- INIT
-- ---------------------------------------
-- --buff drag frame
-- local bf = CreateFrame("Frame", "rBFS_BuffDragFrame", UIParent)
-- bf:SetSize(cfg.buffFrame.button.size, cfg.buffFrame.button.size)
-- bf:SetPoint(cfg.buffFrame.pos.a1, cfg.buffFrame.pos.af, cfg.buffFrame.pos.a2, cfg.buffFrame.pos.x, cfg.buffFrame.pos.y)
-- if cfg.buffFrame.userplaced then
--     rCreateDragFrame(bf, dragFrameList, -2, true) --frame, dragFrameList, inset, clamp
-- end
-- if not cfg.combineBuffsAndDebuffs then
--     --debuff drag frame
--     local df = CreateFrame("Frame", "rBFS_DebuffDragFrame", UIParent)
--     df:SetSize(cfg.debuffFrame.button.size, cfg.debuffFrame.button.size)
--     df:SetPoint(
--         cfg.debuffFrame.pos.a1,
--         cfg.debuffFrame.pos.af,
--         cfg.debuffFrame.pos.a2,
--         cfg.debuffFrame.pos.x,
--         cfg.debuffFrame.pos.y
--     )
--     if cfg.debuffFrame.userplaced then
--         rCreateDragFrame(df, dragFrameList, -2, true) --frame, dragFrameList, inset, clamp
--     end
-- end
-- --temp enchant stuff
-- applySkin(TempEnchant1)
-- applySkin(TempEnchant2)
-- applySkin(TempEnchant3)
-- --position the temp enchant buttons
-- TempEnchant1:ClearAllPoints()
-- TempEnchant1:SetPoint("TOPRIGHT", rBFS_BuffDragFrame, "TOPRIGHT", 0, 0) --button will be repositioned later in case temp enchant and consolidated buffs are both available
-- TempEnchant2:ClearAllPoints()
-- TempEnchant2:SetPoint("TOPRIGHT", TempEnchant1, "TOPLEFT", -cfg.buffFrame.colSpacing, 0)
-- TempEnchant3:ClearAllPoints()
-- TempEnchant3:SetPoint("TOPRIGHT", TempEnchant2, "TOPLEFT", -cfg.buffFrame.colSpacing, 0)
-- hooksecurefunc("BuffFrame_UpdateAllBuffAnchors", updateAllBuffAnchors)
-- hooksecurefunc("DebuffButton_UpdateAnchors", updateDebuffAnchors)
-- local function formatTime(time)
--     local seconds = floor(mod(time, 60))
--     local minutes = floor(time / 60)
--     minutes = ceil(time / 60)
--     if minutes > 1 then
--         return minutes .. "m"
--     else
--         return seconds .. "s"
--     end
-- end
-- local function onAuraDurationUpdate(aura, time)
--     local duration = getglobal(aura:GetName() .. "Duration")
--     if (time) then
--         duration:SetText(formatTime(time))
--         duration:Show()
--     else
--         duration:Hide()
--     end
-- end
-- local function onAuraUpdate(auraSlot, index, filter)
--     local auraName = auraSlot .. index
--     local aura = getglobal(auraName)
--     local auraDuration = getglobal(auraName .. "Duration")
--     if not auraDuration then
--         return
--     end
--     local name, _, _, _, _, expirationTime = UnitAura("player", index, filter)
--     if (name and expirationTime > 0) then
--         auraDuration:Show()
--     else
--         auraDuration:Hide()
--     end
-- end
-- -- Add or remove aura event
-- hooksecurefunc("AuraButton_Update", onAuraUpdate)
-- -- Aura duration update event
-- hooksecurefunc("AuraButton_UpdateDuration", onAuraDurationUpdate)

BuffFrame:SetScale(1.2)

-- Remove gap in buff timers & color the format
local function TimeFormat(button, time)
    local duration = _G[button:GetName() .. "Duration"]
    local floor, fmod = math.floor, math.fmod
    local h, m, s, text

    if time <= 0 then
        text = ""
    elseif time < 3600 and time > 60 then
        h = floor(time / 3600)
        m = floor(fmod(time, 3600) / 60 + 1)
        s = fmod(time, 60)
        text = duration:SetFormattedText("|r%d|rm", m)
    elseif time < 60 then
        m = floor(time / 60)
        s = fmod(time, 60)
        text = m == 0 and duration:SetFormattedText("|r%d|rs", s)
    else
        h = floor(time / 3600 + 1)
        text = duration:SetFormattedText("|r%d|rh", h)
    end
    return text
end

local EventFrame = CreateFrame("Frame")
EventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
EventFrame:SetScript(
    "OnEvent",
    function()
        -- BuffFrame:ClearAllPoints()
        -- BuffFrame:SetPoint("TOPLEFT", MinimapCluster, -60, -20)
        -- BuffFrame.SetPoint = function()
        -- end

        hooksecurefunc("AuraButton_UpdateDuration", TimeFormat)

    end
)



