local manager = CompactRaidFrameManager
manager:SetAlpha(0)

-- look through a frame's parents
local function findParent(frame, target)
    if frame == target then
        return true
    elseif frame then
        return findParent(frame:GetParent(), target)
    end
end
manager:HookScript(
    "OnEnter",
    function(self)
        self:SetAlpha(1)
    end
)
manager:HookScript(
    "OnLeave",
    function(self)
        if manager.collapsed and not findParent(GetMouseFocus(), self) then
            self:SetAlpha(0)
        end
    end
)
manager.toggleButton:HookScript(
    "OnClick",
    function()
        if manager.collapsed then
            manager:SetAlpha(0)
        end
    end
)
-- keep the container frame visible
manager.container:SetIgnoreParentAlpha(true)
manager.containerResizeFrame:SetIgnoreParentAlpha(true)
manager:Show()
manager.Hide = function()
end

local CRFC_OnEvent = CompactRaidFrameContainer_OnEvent
function CompactRaidFrameContainer_OnEvent(self, event, ...)
    -- Call original to perform its default behavior, also helps future protect this hook
    CRFC_OnEvent(self, event, ...)
    -- If all these are true, then the above call already did the TryUpdate
    local unit = ... or ""
    if (unit == "player" or strsub(unit, 1, 4) == "raid" or strsub(unit, 1, 5) == "party") then
        return
    end
    -- Always update the RaidFrame
    if (event == "UNIT_PET") and (self.displayPets) then
        CompactRaidFrameContainer_TryUpdate(self)
    end
end

LoadAddOn("Blizzard_CompactRaidFrames")

CRFSort_Group = function(t1, t2)
    if UnitIsUnit(t1, "player") then
        return false
    elseif UnitIsUnit(t2, "player") then
        return true
    else
        return t1 < t2
    end
end

CompactRaidFrameContainer.flowSortFunc = CRFSort_Group
DefaultCompactUnitFrameOptions.displayRoleIcon = false

-- Remove server name from raid frames
hooksecurefunc("CompactUnitFrame_UpdateName", function(frame)
    local inInstance, instanceType = IsInInstance()
    local name = frame.name;
    local xName = GetUnitName(frame.unit, true);
  
    if (instanceType == "pvp" or instanceType == "arena") then
      if (xName) then
          local noRealm = gsub(xName, "%-[^|]+", "");
          name:SetText(noRealm);
        
      end
    end
  end);


local f = CreateFrame("Frame")
f:RegisterEvent("PLAYER_LOGIN")
f:SetScript("OnEvent", function(self, event)
    if event == "PLAYER_LOGIN" then
        -- Show raid frames when solo
        if (GoodmanUIDB.RAIDFRAMES.SOLO) then
            local getDAF = GetDisplayedAllyFrames
            function GetDisplayedAllyFrames()
                local daf = getDAF()
                if daf == "party" or not daf then
                    return "raid"
                else
                    return daf
                end
            end
        end
    end
    self:UnregisterEvent("PLAYER_LOGIN")
    self:SetScript("OnEvent", nil)
end);
